﻿using System.Collections.Generic;
using System.ComponentModel;
using Wisej.Core;
using Wisej.Web;

namespace WisejTest
{
    public class BarCodeWidget : Widget
    {

        /// <summary>
        /// Overridden to return our list of script resources.
        /// </summary>
        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override List<Package> Packages
        {
            get
            {
                if (base.Packages.Count == 0) {
                    base.Packages.AddRange(new Package[] {
                        new Package()
                        {
                            Name = "ej.widgets.all.min.css",
                            Source = "http://cdn.syncfusion.com/15.1.0.41/js/web/flat-azure/ej.web.all.min.css"
                        },
                        new Package()
                        {
                            Name = "jquery-1.10.2.min.js",
                            Source = "http://cdn.syncfusion.com/js/assets/external/jquery-1.10.2.min.js"
                        },
                        new Package()
                        {
                            Name = "jquery.easing.1.3.min.js",
                            Source = "http://cdn.syncfusion.com/js/assets/external/jquery.easing.1.3.min.js"
                        },
                        new Package()
                        {
                            Name = "jsrender.min.js",
                            Source = "http://cdn.syncfusion.com/js/assets/external/jsrender.min.js"
                        },
                        new Package()
                        {
                            Name = "ej.web.all.min.js",
                            Source = "http://cdn.syncfusion.com/15.1.0.41/js/web/ej.web.all.min.js"
                        }
                    });
                }
                return base.Packages;
            }
        }

        /// <summary>
        /// Overridden to create our initialization script.
        /// </summary>
        [Browsable(false)]
        [DesignerSerializationVisibility(DesignerSerializationVisibility.Hidden)]
        public override string InitScript
        {
            get { return BuildInitScript(); }
            set { }
        }

        private string BuildInitScript()
        {
            dynamic options = new DynamicObject();

            var script = $@"this.init = function() {{
		            var self = this;
		            var barCode = $(this.container).ejBarcode({{
                        text: ""http://www.google.fr/"",
                        symbologyType: ""qrbarcode""
                    }});
                }};";

            script = script.Replace("$options", options.ToString());
            return script;
        }

        public string BarCodeType { get; set; }
        public string BarCodeText { get; set; }

    }
}